/* zlib test */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <zlib.h>

void do_compress(void) {
  z_stream z;
  char input_buffer[1024];
  char output_buffer[1024];
  int status;
  z.avail_in = 0;
  z.next_out = output_buffer;
  z.avail_out = 1024;
  z.zalloc = 0;
  z.zfree = 0;
  z.opaque = 0;
  deflateInit(&z,9);
  for (;;) {
    if (z.avail_in == 0) {
      z.next_in = input_buffer;
      z.avail_in = read(0,input_buffer,sizeof(input_buffer));
    }
    if (z.avail_in == 0) {
       break;
    }  /* if (z.avail_in == 0) */
    status = deflate( &z, Z_SYNC_FLUSH );
    int count = 1024 - z.avail_out;
    if (count) {
      write(1,output_buffer,count);
    }
    z.next_out = output_buffer;
    z.avail_out = 1024;
  }
  deflateEnd(&z);
} /* void do_compress(void) */

void do_uncompress(void) {
  z_stream z;
  char input_buffer[1024];
  char output_buffer[1024];
  int status;
  z.avail_in = 0;
  z.next_out = output_buffer;
  z.avail_out = 1024;
  z.zalloc = 0;
  z.zfree = 0;
  z.opaque = 0;
  inflateInit(&z);
  for (;;) {
    if (z.avail_in == 0) {
      z.next_in = input_buffer;
      z.avail_in = read(0,input_buffer,sizeof(input_buffer));
    }
    if (z.avail_in == 0) {
       break;
    }  /* if (z.avail_in == 0) */
    status = inflate( &z, Z_SYNC_FLUSH );
    int count = 1024 - z.avail_out;
    if (count) {
      write(1,output_buffer,count);
    }
    z.next_out = output_buffer;
    z.avail_out = 1024;
  }
  inflateEnd(&z);
} /* void do_uncompress(void) */

int main(int argc, char * argv[]) {
  int compress = 1;
  if (argc>1 && strcmp(argv[1],"-d")==0) {
    compress = 0;
  } /* if (strcmp(argv[1],"-d")==0) */
  if (compress) {
    do_compress();
  } else {
    do_uncompress();
  }
  return 0;
} /* int main(int argc, char * argv[]) */
